<?php

namespace Modules\User\Repositories\Contracts;

use Illuminate\Database\Eloquent\Collection;
use Modules\User\Entities\Address;

interface AddressRepositoryInterface
{
    public function getAllPaginated(int $perPage = 10, string $search = '');

    public function getAllWithRelationsPaginated(
        int $perPage = 10,
        string $search = '',
        string $sortBy = 'address_type',
        string $sortOrder = 'asc'
    );

    public function getAllWithRelations(string $search = ''): Collection;

    public function create(array $data): Address;

    public function findById(string $id): ?Address;

    public function delete(string $id): bool;

    public function all(string $search = ''): Collection;
}
